<template>
    <div>
        <crumbs title="标签组维护" style="min-width: 980px">
            <el-form :inline="true" class="demo-form-inline">
                <el-form-item label="标签类型：">
                    <el-select size="mini" v-model="filter.tagType[0]" placeholder="标签类型" clearable>
                        <el-option v-for="item in tagTypes" :label="item.name" :value="item.val" :key="item.id"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="标签归属：">
                    <el-select size="mini" v-model="filter.tagAdscription" @change="getValue"  placeholder="标签归属" clearable>
                        <el-option v-for="item in Adscriptions" :label="item.name" :value="item.val" :key="item.id" ></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="标签系统名称：">
                    <el-input size="mini" v-model="filter.tagSysName" placeholder="标签系统名称" clearable></el-input>
                </el-form-item>
                <el-form-item>
                    <el-button size="mini" @click="filterDatas">确认</el-button>
                    <el-button size="mini" type="primary" @click="addTagGroup">添加标签组</el-button>
                </el-form-item>
            </el-form>
        </crumbs>
        <div class="contents">
            <el-table
                :data="list"
                border
                style="width: 100%">
                <el-table-column
                    :resizable = "false"
                    type="index"
                    :index = 'indexMethod'
                    label="编号"
                    width="60">
                </el-table-column>
                <el-table-column
                    :resizable = "false"
                    prop="gmtModified"
                    label="操作时间"
                    width="180">
                </el-table-column>
                <el-table-column
                    :resizable = "false"
                    prop="typeCn"
                    label="标签归属">
                </el-table-column>
                <el-table-column
                    :resizable = "false"
                    prop="tagTypeCn"
                    label="标签类型">
                </el-table-column>
                <el-table-column
                    :resizable = "false"
                    prop="tagName"
                    label="标签系统名称">
                </el-table-column>
                <el-table-column
                    :resizable = "false"
                    prop="modifier"
                    label="操作人">
                </el-table-column>
                <el-table-column
                    :resizable = "false"
                    prop="operate"
                    label="操作">
                    <template slot-scope="scope">
                        <el-button  @click="modifyTagGroup(scope.row)" type="text" size="small">修改</el-button>
                        <el-button @click="showDelDialog(scope.row.id)" class="delete" type="text" size="small">删除</el-button>
                    </template>
                </el-table-column>
            </el-table>
        <div class="pagination">
            <el-pagination v-if="total>pageSize"
                       :current-page.sync="currentPage"
                       @current-change="currentChange"
                       background
                       :page-size="pageSize"
                       layout="total,prev, pager, next, jumper"
                       :total="total">
            </el-pagination>
        </div>
        
        </div>
       <!--  <div class="pagination">
           <el-pagination v-if="total>pageSize"
                      :current-page.sync="currentPage"
                      @current-change="currentChange"
                      background
                      :page-size="pageSize"
                      layout="total,prev, pager, next, jumper"
                      :total="total">
           </el-pagination>
       </div> -->
        
    </div>
</template>

<script>
import api from '@api/icss.js';

export default {
    name: 'tag-group',
    data: function() {
        return {
            list: [],
            tagTypes: [],
            Adscriptions: [],   //标签归属列表
            tagTypesList: [],   //标签类型列表
            filter: {
                tagType: [], //标签类型
                tagAdscription: '', //标签归属
                tagSysName: '', //标签系统名称
            },
            currentPage: 1,
            pageSize: 10,
            total: 0,
        }
    },
    created() {
        this.getDropList().then(() => {
            this.getDataList()
        })
        
    },
    methods: {
        getValue(val) {
            console.log('changeVal', val, this.filter.tagAdscription)
        },
        getDropList() {
            return api.getDropList().then((res) =>{
                // console.log('dropList', res)
                if(res.data.code === '0') {
                    this.Adscriptions = res.data.data[1];
                    this.tagTypes =  res.data.data[3];
                    for (var i = 0; i < this.tagTypes.length; i++) {
                        this.tagTypesList.push(this.tagTypes[i].val)
                    }
                }
                 
            })
        },
        getDataList() {
            const param = this.getFilterItems();
            api.getTagList(param).then((res) => {
                const list = res.data.data.records
                for (var i = 0; i < list.length; i++) {
                    for (var j =  0; j < this.tagTypes.length; j++) {
                        if(list[i].tagType == this.tagTypes[j].val) {
                            list[i].tagTypeCn = this.tagTypes[j].name
                        }
                    }
                    for (var z =  0; z < this.Adscriptions.length; z++) {
                        if(list[i].type == this.Adscriptions[z].val) {
                            list[i].typeCn = this.Adscriptions[z].name
                        }
                    }
                   
                }
                this.list = list;
                this.total = res.data.data.total;
            })
        },
        filterDatas() {
            this.currentPage = 1;
            this.getDataList();
        },
        addTagGroup() {
            this.$router.push({path:'LT-YXSJWH-TJBQZ'})
        },
        modifyTagGroup(row) {
            api.detailsTag({id:row.id,sexType:row.sexType,age:row.age}).then((res)=>{
                const {code,data,msg} = res.data;
                if(code=='0'){
                    const item = Object.assign({},row,data);
                    console.log('item', item)
                    this.$router.push({name:'AddLabelGroup',params:{isEdit:true,data:item}});
                }else{
                    this.$message({
                    message: msg,
                    type: 'warning'
                    });
                }
            });
        },
        currentChange(next) {
            this.currentPage = next;
            this.getDataList();
            // if (this.cacheData[next]) {       //如果已请求过该页数据，则使用缓存不重复请求
            //     this.list = this.cacheData[next];
            // } else {
            //     this.getDataList();
            // }
        },
        getFilterItems() {
            const param = {
                tagTypeList: this.filter.tagType[0] && this.filter.tagType|| this.tagTypesList,
                current: this.currentPage,
                size: this.pageSize,
                type: this.filter.tagAdscription,
                tagName: this.filter.tagSysName
            };
            return param;
        },
        indexMethod(index) {
            return ((this.currentPage - 1) * this.pageSize) + index + 1;
        },
        getTagType(val) {
            return val
        },
        warning(msg,type){
          this.$message({
            showClose: true,
            message:msg,
            type:type||'warning'
          })
        },
        showConfirmDialog(msg,resolve){
          this.$alert(msg, '提示', {
            confirmButtonText: '确定',
            type: 'warning'
          }).then(() => {
            resolve();
          }).catch(() => {});
        },
        showDelDialog(id){
          this.showConfirmDialog('是否删除该标签组？',()=>{
            api.deleteTagGroup({ids:id}).then((res)=>{
              if(res.data.code=='0'){
                this.getDataList();
                this.warning(res.data.msg || '操作成功','success');
              }else{
                this.warning(res.data.msg);
              }
            }).catch((error)=>{
              this.warning(error);
            })
          });
        }
    }
}
</script>


<style lang="less">
    @import "../../less/admin.less";
    .delete{
       color: red;
    }
    .delete:hover {
        color: red;
    } 
    .pagination {
        min-width: 1010px;
    }
</style>